#ifndef MOLECULE_H
#define MOLECULE_H

#include <cstdint>
#include <vector>

template<typename T>
class Molecule
{
  public:
    int64_t _moleculeId;
    int32_t _labelsCount;
    T _maxLabelDistance;
    bool _reverseMolecule;

    // vector of relative positions of labels for this molecule (distances between labels)
    std::vector<T> _labelDistances;

    Molecule(int64_t moleculeId, bool reverseMolecule)
    {
      _moleculeId = moleculeId;
      _labelsCount = 0;
      _maxLabelDistance = 0;
      _reverseMolecule = reverseMolecule;
      std::vector<T> _labelDistances;
    }
};

#endif