#ifndef RUN_H
#define RUN_H

#include <cstdint>
#include <vector>
#include "molecule.hpp"

template<typename T>
class Run
{
  public:
    int32_t _runId;
    // count of molecules in this run
    int32_t _moleculesCount;
    // max label distance (relative length) from all molecules in this run
    T _maxLabelDistance;
    // left out molecules count
    int32_t _leftOutMoleculesCount;
    // vector of molecules, those contains relative positions of labels
    std::vector<Molecule<T>*> _molecules;

    Run(int runId)
    {
      _runId = runId;
      _moleculesCount = 0;
      _leftOutMoleculesCount = 0;
      _maxLabelDistance = 0;
      std::vector<Molecule<T>*> _molecules;
    }
};

#endif